# Controller API

## Voraussetzungen

* Prüfe ob Python Version 3.x installiert ist
> python --version

## Setup private Python Repository (pip Repro)

* Lasse Deinen Nutzer beim Nexus freischalten (https://update.fischertechnik-cloud.com)
* Installiere alle abhängigen Bibliotheken
> cd txtapi
> pip install -r requirements.txt --extra-index-url https://update.fischertechnik-cloud.com/repository/ft-txt-lib/simple/
* Benutzername und Password müssen dann auf der Kommandozeile eingegeben werden

## Git Hook erstellen

Konfiguriere einen Git-Hook, sodass die Versionsnummern automatisch inkrementiert werden.

> git config --local core.hooksPath .githooks/

## Docker
Start der Api:
```code
docker-compose up --build
```
Danach erreich unter **http://localhost/api/v1/ui/**

## Community FW
Vorbereitung:
1. Auf dem eigenen Rechner müssen Python3 und pip vorhanden sein
2. Per pip fabric installieren (pip install fabric)
3. Auf dem TXT muss die Community Firmware installiert sein und das WLAN eingerichet sein

Ablauf:
1. fabric deploy -h 'ip-adresse'
* Auf dem Controller muss der SSH und root Zugriff der Tastendruck bestätigt werden
* An einer Stelle wird nach Credentials gefragt, hier bitte die Accountdaten für update.fischertechnik-cloud.com eingeben
2. Im Menü des Controller die Applikation TXT-API ausführen
3. Sobald der Status auf 'running' steht, kann der Controller genutzt werdne
4. ROBOPro2 öffnen (nicht die Webapplikation)
* [https://update.fischertechnik-cloud.com/#browse/browse:ft-roboticstudio]
5. Über das kleine Router Symbol kann der Controller verbunden werden
* Im Dialogfeld die Ip-Adresse des Controllers und den Port 8080 eingeben (Beispiel: 192.168.1.2:8080)
* Der Port 8080 ist aktuell noch notwendig, da in der Community Firmware automatisch ein Server startet, der Port 80 allokiert
6. Wenn alles funktioniert hat, sollte der Router nun grün sein (rot im Fehlerfall)
7. Über den Start- und den Stopknopf kann nun Code ausgeführt und beendet werden.

## Release durchführen

* Prüfen ob der letzte Stand ohne Änderungen lokal vorhanden ist 

> git pull
 
> git status
   
* Abhängigkeit zur Controllerlib aktualisieren
(Datei: txtapi/setup.py)
> ft-controllerlib==2.0.0

* Letzten Tag ermittlen
> git tag

* Neuen Tag erstellen und im Repository veröffentlichen
> git tag release/2.0.0 -m "Message with last changes"

* Tags der folgenden Form lösen ein Release aus:

> release/2.0.0a0 = alpha

> release/2.0.0b0 = beta

> release/2.0.0rc0 = release candidate

> release/2.0.0 = release

* Bei einem alpha, beta und rc wird nur zum Nexus deployed

* Bei einem finalen Release wird auch der stable-Branch aktualisiert.

* Der Tag kann auch direkt in Gerrit gesetzt werden:
  https://review.beemo.eu/admin/repos/ft/python/roboticsstudio/controllerapi,tags
