#! /usr/bin/env python3
# -*- coding: utf-8 -*-

import glob
import os
import signal
import sys
import time

from TouchStyle import *

class FtcGuiApplication(TouchApplication):
    def __init__(self, args):
        TouchApplication.__init__(self, args)

        self.process = "txtapi"

        # Creates an empty MainWindow
        w = TouchWindow("TXT-API")

        # Create a label
        vbox = QVBoxLayout()

        status = QLabel()
        status.setText('Server status:')
        status.setAlignment(Qt.AlignCenter)
        vbox.addWidget(status)

        self.info = QLabel()
        self.info.setAlignment(Qt.AlignCenter)
        vbox.addWidget(self.info)

        self.btnStart = QPushButton('Start')
        self.btnStart.clicked.connect(self.startBackgroundServer)
        vbox.addWidget(self.btnStart)

        self.btnStop = QPushButton('Stop')
        self.btnStop.clicked.connect(self.stopBackgroundServer)
        vbox.addWidget(self.btnStop)

        w.centralWidget.setLayout(vbox)

        self.checkServerStatus()

        w.show()
        self.exec_()

    def initBackgroundServer(self):
        self.info.setText('booting')
        self.info.setStyleSheet('color: orange; background-color: white')
        self.btnStart.setDisabled(True)
        self.processEvents()

    def startBackgroundServer(self):
        self.initBackgroundServer()
        os.system("cd /home/ftc/txtapi && {0} &".format(self.process))
        time.sleep(25)
        self.checkServerStatus()

    def stopBackgroundServer(self):
        os.system("killall -9 {0}".format(self.process))
        self.checkServerStatus()

    def checkServerStatus(self):
        processes = os.popen("ps -Af").read()
        if self.process in processes:
            self.info.setText('running')
            self.info.setStyleSheet('color: green; background-color: white')
            self.btnStart.setDisabled(True)
            self.btnStop.setDisabled(False)
        else:
            self.info.setText('not running')
            self.info.setStyleSheet('color: red; background-color: white')
            self.btnStart.setDisabled(False)
            self.btnStop.setDisabled(True)

if __name__ == "__main__":
    FtcGuiApplication(sys.argv)
