import os

from deploy import colorized_output as co
from deploy.mounts import Mounts
from deploy.python_environment import PythonEnvironment
from deploy.repository import Repository

from fabric import Connection

USER = 'ftc'

class Deployment:
    def __init__(self, host):
        self.host = host
        self.con = Connection(host = host, user = USER)

    def copy_ssh_key(self):
        co.print_warning('Please authorize ssh-login on txt to copy ssh-key to authorized keys')
        os.system("ssh {0}@{1} 'mkdir -p .ssh' && scp $HOME/.ssh/id_rsa.pub {0}@{1}:.ssh/authorized_keys".format(USER, self.host))

    def check_mounts(self):
        mnts = Mounts(self.con)
        mnts.check_mounts()

    def check_pip_and_libraries(self):
        pyenv = PythonEnvironment(self.con)
        pyenv.check_pip()
        pyenv.check_pip_libraries()
        pyenv.add_ftc_path()

    def deploy_flask_app(self):
        repo = Repository(self.con)
        repo.uploadFolder('../txtapi')
        repo.uploadAppFolder('api-app')
        repo.replace_ip(self.host)
        repo.replace_env('environment_cfw.py')
