import os

from deploy import colorized_output as co
from deploy.deployment import Deployment

from invoke import task

def set_ctx(ctx, host):
    deployment = Deployment(host)
    ctx.update({'deploy': deployment})

@task(help={'host': "IP of the txt-controller"})
def copy_ssh_key(ctx, host):
    """
    copy the own ssh-key to the txt-controller
    """
    set_ctx(ctx, host)
    ctx.deploy.copy_ssh_key()

@task(help={'host': "IP of the txt-controller"})
def deploy_flask_app(ctx, host):
    """
    deploys the flask-app on the txt-controller
    """
    set_ctx(ctx, host)
    ctx.deploy.deploy_flask_app()

@task(help={'host': "IP of the txt-controller"})
def deploy(ctx, host):
    """
    Setup and deploy flask-server on txt-controller
    """
    set_ctx(ctx, host)
    co.print_info("Step 1/2 >> Copying SSH-Key to TXT")
    copy_ssh_key(ctx, host)
    co.print_info("Step 2/2 >> Copying flaskConnexion-folder to TXT")
    deploy_flask_app(ctx, host)
    co.print_success('Deployment successfully finished')
    co.print_success("You can start the swagger server by running the 'TXT-API' application")
