#!/usr/bin/env python3
import connexion
import ftlock
from waitress import serve
from flask_socketio import SocketIO, emit
from txtapi.txt.txt import Txt

from txtapi import encoder
from txtapi.cache import CachedSpecification
from flask_cors import CORS

APPLICATION_PID = -1


def on_notify(state):
    global APPLICATION_PID
    if state == -1:
        return
    state = chr(state)
    if state is 'R':
        APPLICATION_PID = ftlock.pid()
    elif state is 'F' or state is 'S':
        APPLICATION_PID = -1


def main():
    ftlock.subscribe(on_notify)
    Txt.get_instance()
    # use cache for openapi.yaml
    connexion.spec.Specification.from_file = CachedSpecification.from_file
    # init connexion
    app = connexion.App(__name__, specification_dir='./openapi/')
    app.app.json_encoder = encoder.JSONEncoder
    app.add_api(
        'openapi.yaml',
        arguments={'title': 'ft-controller-api'},
        pythonic_params=True
    )
    # start flask
    flask_app = app.app
    CORS(flask_app, resources={r"/api/*": {"origins": "*"}})
    serve(app, host='127.0.0.1', port=8080, threads=12)

if __name__ == '__main__':
    main()

