import flask
from txtapi.handlers import workspace_handler


def create_workspace(workspace_name):  # noqa: E501
    """create_workspace

    Creates a new workspace # noqa: E501
    :param workspace_name: workspace_name of the workspace
    :type workspace_name: str

    :rtype: Workspace
    """
    return workspace_handler.create_workspace(workspace_name)


def delete_file_of_workspace(workspace_name, filename):  # noqa: E501
    """delete_file_of_workspace

    Delete a file of a workspace identified by its name # noqa: E501

    :param workspace_name: workspace_name of the workspace
    :type workspace_name: str
    :param filename: Name of the file
    :type filename: str

    :rtype: None
    """
    return workspace_handler.delete_file_of_workspace(workspace_name, filename)


def delete_files_of_workspace(workspace_name):  # noqa: E501
    """delete_files_of_workspace

    Delete all files of a workspace # noqa: E501

    :param workspace_name: workspace_name of the workspace
    :type workspace_name: str

    :rtype: None
    """
    return workspace_handler.delete_files_of_workspace(workspace_name)

def delete_workspace(workspace_name):  # noqa: E501
    """delete_workspace

    Deletes a workspace identified by id # noqa: E501

    :param workspace_name: workspace_name of the workspace
    :type workspace_name:

    :rtype: None
    """
    return workspace_handler.delete_workspace(workspace_name)


def get_file_of_workspace(workspace_name, filename):  # noqa: E501
    """get_file_of_workspace

    Get a file of a workspace identified by its name # noqa: E501

    :param workspace_name: workspace_name of the workspace
    :type workspace_name: str
    :param filename: Name of the file
    :type filename: str

    :rtype: file
    """
    return workspace_handler.get_file_of_workspace(workspace_name, filename)


def get_files_of_workspace(workspace_name):  # noqa: E501
    """get_files_of_workspace

    Get all files of a workspace # noqa: E501

    :param workspace_name: workspace_name of the workspace
    :type workspace_name: str

    :rtype: List[file]
    """
    return workspace_handler.get_files_of_workspace(workspace_name)


def get_workspace(workspace_name):  # noqa: E501
    """get_workspace

    Gets a workspace identified by id # noqa: E501

    :param workspace_name: workspace_name of the workspace
    :type workspace_name: str

    :rtype: Workspace
    """
    return workspace_handler.get_workspace(workspace_name)


def get_workspaces():  # noqa: E501
    """get_workspaces

    Gets list of workspaces # noqa: E501


    :rtype: List[Workspace]
    """
    return workspace_handler.get_workspaces()

def upload_files_to_workspace(workspace_name):  # noqa: E501
    """Upload files

    Uploads files to a workspace. # noqa: E501

    :param workspace_name: Name of workspace
    :type workspace_name: str

    :rtype: None
    """
    files = flask.request.files.getlist("files")
    return workspace_handler.upload_files_to_workspace(workspace_name, files)

