# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from txtapi.models.base_model_ import Model
from txtapi.models.ball_detector import BallDetector
from txtapi.models.color_detector import ColorDetector
from txtapi.models.line_detector import LineDetector
from txtapi.models.motion_detector import MotionDetector
from txtapi.models.rectangle import Rectangle
from txtapi import util

from txtapi.models.ball_detector import BallDetector  # noqa: E501
from txtapi.models.color_detector import ColorDetector  # noqa: E501
from txtapi.models.line_detector import LineDetector  # noqa: E501
from txtapi.models.motion_detector import MotionDetector  # noqa: E501
from txtapi.models.rectangle import Rectangle  # noqa: E501

class ImageRecognitionConfig(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, blocked_areas=None, motion_detectors=None, color_detectors=None, ball_detectors=None, line_detectors=None):  # noqa: E501
        """ImageRecognitionConfig - a model defined in OpenAPI

        :param blocked_areas: The blocked_areas of this ImageRecognitionConfig.  # noqa: E501
        :type blocked_areas: List[Rectangle]
        :param motion_detectors: The motion_detectors of this ImageRecognitionConfig.  # noqa: E501
        :type motion_detectors: List[MotionDetector]
        :param color_detectors: The color_detectors of this ImageRecognitionConfig.  # noqa: E501
        :type color_detectors: List[ColorDetector]
        :param ball_detectors: The ball_detectors of this ImageRecognitionConfig.  # noqa: E501
        :type ball_detectors: List[BallDetector]
        :param line_detectors: The line_detectors of this ImageRecognitionConfig.  # noqa: E501
        :type line_detectors: List[LineDetector]
        """
        self.openapi_types = {
            'blocked_areas': List[Rectangle],
            'motion_detectors': List[MotionDetector],
            'color_detectors': List[ColorDetector],
            'ball_detectors': List[BallDetector],
            'line_detectors': List[LineDetector]
        }

        self.attribute_map = {
            'blocked_areas': 'blocked_areas',
            'motion_detectors': 'motion_detectors',
            'color_detectors': 'color_detectors',
            'ball_detectors': 'ball_detectors',
            'line_detectors': 'line_detectors'
        }

        self._blocked_areas = blocked_areas
        self._motion_detectors = motion_detectors
        self._color_detectors = color_detectors
        self._ball_detectors = ball_detectors
        self._line_detectors = line_detectors

    @classmethod
    def from_dict(cls, dikt) -> 'ImageRecognitionConfig':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The image-recognition_config of this ImageRecognitionConfig.  # noqa: E501
        :rtype: ImageRecognitionConfig
        """
        return util.deserialize_model(dikt, cls)

    @property
    def blocked_areas(self):
        """Gets the blocked_areas of this ImageRecognitionConfig.


        :return: The blocked_areas of this ImageRecognitionConfig.
        :rtype: List[Rectangle]
        """
        return self._blocked_areas

    @blocked_areas.setter
    def blocked_areas(self, blocked_areas):
        """Sets the blocked_areas of this ImageRecognitionConfig.


        :param blocked_areas: The blocked_areas of this ImageRecognitionConfig.
        :type blocked_areas: List[Rectangle]
        """

        self._blocked_areas = blocked_areas

    @property
    def motion_detectors(self):
        """Gets the motion_detectors of this ImageRecognitionConfig.


        :return: The motion_detectors of this ImageRecognitionConfig.
        :rtype: List[MotionDetector]
        """
        return self._motion_detectors

    @motion_detectors.setter
    def motion_detectors(self, motion_detectors):
        """Sets the motion_detectors of this ImageRecognitionConfig.


        :param motion_detectors: The motion_detectors of this ImageRecognitionConfig.
        :type motion_detectors: List[MotionDetector]
        """

        self._motion_detectors = motion_detectors

    @property
    def color_detectors(self):
        """Gets the color_detectors of this ImageRecognitionConfig.


        :return: The color_detectors of this ImageRecognitionConfig.
        :rtype: List[ColorDetector]
        """
        return self._color_detectors

    @color_detectors.setter
    def color_detectors(self, color_detectors):
        """Sets the color_detectors of this ImageRecognitionConfig.


        :param color_detectors: The color_detectors of this ImageRecognitionConfig.
        :type color_detectors: List[ColorDetector]
        """

        self._color_detectors = color_detectors

    @property
    def ball_detectors(self):
        """Gets the ball_detectors of this ImageRecognitionConfig.


        :return: The ball_detectors of this ImageRecognitionConfig.
        :rtype: List[BallDetector]
        """
        return self._ball_detectors

    @ball_detectors.setter
    def ball_detectors(self, ball_detectors):
        """Sets the ball_detectors of this ImageRecognitionConfig.


        :param ball_detectors: The ball_detectors of this ImageRecognitionConfig.
        :type ball_detectors: List[BallDetector]
        """

        self._ball_detectors = ball_detectors

    @property
    def line_detectors(self):
        """Gets the line_detectors of this ImageRecognitionConfig.


        :return: The line_detectors of this ImageRecognitionConfig.
        :rtype: List[LineDetector]
        """
        return self._line_detectors

    @line_detectors.setter
    def line_detectors(self, line_detectors):
        """Sets the line_detectors of this ImageRecognitionConfig.


        :param line_detectors: The line_detectors of this ImageRecognitionConfig.
        :type line_detectors: List[LineDetector]
        """

        self._line_detectors = line_detectors
