# coding: utf-8

from __future__ import absolute_import

from flask import json
from six import BytesIO

from txtapi.models.breakpoint import Breakpoint  # noqa: E501
from txtapi.models.enabled import Enabled  # noqa: E501
from txtapi.models.error_message import ErrorMessage  # noqa: E501
from txtapi.models.expression import Expression  # noqa: E501
from txtapi.models.inline_response_default import InlineResponseDefault  # noqa: E501
from txtapi.models.program_location import ProgramLocation  # noqa: E501
from txtapi.test import BaseTestCase


class TestDebuggerController(BaseTestCase):
    """DebuggerController integration test stubs"""

    def test_add_expression(self):
        """Test case for add_expression

        
        """
        expression = Expression()
        response = self.client.open(
            '/v1/debugger/{workspace_name}/expressions'.format(workspace_name='workspace_name_example),
            method='POST',
            data=json.dumps(expression),
            content_type='application/json')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_call_continue(self):
        """Test case for call_continue

        
        """
        response = self.client.open(
            '/v1/debugger/{workspace_name}/continue'.format(workspace_name='workspace_name_example),
            method='POST')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_callstack_down(self):
        """Test case for callstack_down

        
        """
        query_string = [('steps', 1)]
        response = self.client.open(
            '/v1/debugger/{workspace_name}/callstack/down'.format(workspace_name='workspace_name_example),
            method='POST',
            query_string=query_string)
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_callstack_up(self):
        """Test case for callstack_up

        
        """
        query_string = [('steps', 1)]
        response = self.client.open(
            '/v1/debugger/{workspace_name}/callstack/up'.format(workspace_name='workspace_name_example),
            method='POST',
            query_string=query_string)
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_delete_all_breakpoints(self):
        """Test case for delete_all_breakpoints

        
        """
        response = self.client.open(
            '/v1/debugger/{workspace_name}/breakpoints'.format(workspace_name='workspace_name_example),
            method='DELETE')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_delete_breakpoint(self):
        """Test case for delete_breakpoint

        
        """
        response = self.client.open(
            '/v1/debugger/{workspace_name}/breakpoints/{breakpoint_id}'.format(workspace_name='workspace_name_example, breakpoint_id=56),
            method='DELETE')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_get_breakpoints(self):
        """Test case for get_breakpoints

        
        """
        response = self.client.open(
            '/v1/debugger/{workspace_name}/breakpoints'.format(workspace_name='workspace_name_example),
            method='GET')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_get_callstack(self):
        """Test case for get_callstack

        
        """
        response = self.client.open(
            '/v1/debugger/{workspace_name}/callstack'.format(workspace_name='workspace_name_example),
            method='GET')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_get_expressions(self):
        """Test case for get_expressions

        
        """
        response = self.client.open(
            '/v1/debugger/{workspace_name}/expressions'.format(workspace_name='workspace_name_example),
            method='GET')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_get_globals(self):
        """Test case for get_globals

        
        """
        response = self.client.open(
            '/v1/debugger/{workspace_name}/expressions/globals'.format(workspace_name='workspace_name_example),
            method='GET')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_get_locals(self):
        """Test case for get_locals

        
        """
        response = self.client.open(
            '/v1/debugger/{workspace_name}/expressions/locals'.format(workspace_name='workspace_name_example),
            method='GET')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_remove_expression(self):
        """Test case for remove_expression

        
        """
        response = self.client.open(
            '/v1/debugger/{workspace_name}/expressions/{expression_key}'.format(workspace_name='workspace_name_example, expression_key='expression_key_example'),
            method='DELETE')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_restart(self):
        """Test case for restart

        
        """
        args = [List[str]()]
        response = self.client.open(
            '/v1/debugger/{workspace_name}/restart'.format(workspace_name='workspace_name_example),
            method='POST',
            data=json.dumps(args),
            content_type='application/json')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_set_breakpoint(self):
        """Test case for set_breakpoint

        
        """
        breakpoint = Breakpoint()
        response = self.client.open(
            '/v1/debugger/{workspace_name}/breakpoints'.format(workspace_name='workspace_name_example),
            method='POST',
            data=json.dumps(breakpoint),
            content_type='application/json')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_start(self):
        """Test case for start

        
        """
        args = [List[str]()]
        response = self.client.open(
            '/v1/debugger/{workspace_name}/start'.format(workspace_name='workspace_name_example),
            method='POST',
            data=json.dumps(args),
            content_type='application/json')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_step_into(self):
        """Test case for step_into

        
        """
        response = self.client.open(
            '/v1/debugger/{workspace_name}/step-into'.format(workspace_name='workspace_name_example),
            method='POST')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_step_out(self):
        """Test case for step_out

        
        """
        response = self.client.open(
            '/v1/debugger/{workspace_name}/step-out'.format(workspace_name='workspace_name_example),
            method='POST')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_step_over(self):
        """Test case for step_over

        
        """
        response = self.client.open(
            '/v1/debugger/{workspace_name}/step-over'.format(workspace_name='workspace_name_example),
            method='POST')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_stop(self):
        """Test case for stop

        
        """
        response = self.client.open(
            '/v1/debugger/{workspace_name}/stop'.format(workspace_name='workspace_name_example),
            method='POST')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_toggle_breakpoint(self):
        """Test case for toggle_breakpoint

        
        """
        enabled = Enabled()
        response = self.client.open(
            '/v1/debugger/{workspace_name}/breakpoints/{breakpoint_id}'.format(workspace_name='workspace_name_example, breakpoint_id=56),
            method='PATCH',
            data=json.dumps(enabled),
            content_type='application/json')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_toggle_breakpoints(self):
        """Test case for toggle_breakpoints

        
        """
        enabled = Enabled()
        response = self.client.open(
            '/v1/debugger/{workspace_name}/breakpoints'.format(workspace_name='workspace_name_example),
            method='PATCH',
            data=json.dumps(enabled),
            content_type='application/json')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_update_expression(self):
        """Test case for update_expression

        
        """
        query_string = [('command', 'command_example')]
        response = self.client.open(
            '/v1/debugger/{workspace_name}/expressions/{expression_key}'.format(workspace_name='workspace_name_example, expression_key='expression_key_example'),
            method='PUT',
            query_string=query_string)
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))


if __name__ == '__main__':
    import unittest
    unittest.main()
