# coding: utf-8

from __future__ import absolute_import
import unittest

from flask import json
from six import BytesIO

from txtapi.models.error_message import ErrorMessage  # noqa: E501
from txtapi.models.inline_response_default import InlineResponseDefault  # noqa: E501
from txtapi.models.workspace import Workspace  # noqa: E501
from txtapi.test import BaseTestCase


class TestWorkspaceController(BaseTestCase):
    """WorkspaceController integration test stubs"""

    def test_create_workspace(self):
        """Test case for create_workspace

        
        """
        headers = { 
            'Accept': 'application/json',
            'ApiKeyAuth': 'special-key',
        }
        response = self.client.open(
            '/api/v1/workspaces/{workspace_name}'.format(workspace_name='workspace_name_example'),
            method='POST',
            headers=headers)
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_delete_file_of_workspace(self):
        """Test case for delete_file_of_workspace

        
        """
        headers = { 
            'Accept': '*/*',
            'ApiKeyAuth': 'special-key',
        }
        response = self.client.open(
            '/api/v1/workspaces/{workspace_name}/files/{filename}'.format(workspace_name='workspace_name_example', filename='filename_example'),
            method='DELETE',
            headers=headers)
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_delete_files_of_workspace(self):
        """Test case for delete_files_of_workspace

        
        """
        headers = { 
            'Accept': '*/*',
            'ApiKeyAuth': 'special-key',
        }
        response = self.client.open(
            '/api/v1/workspaces/{workspace_name}/files'.format(workspace_name='workspace_name_example'),
            method='DELETE',
            headers=headers)
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_delete_workspace(self):
        """Test case for delete_workspace

        
        """
        headers = { 
            'Accept': '*/*',
            'ApiKeyAuth': 'special-key',
        }
        response = self.client.open(
            '/api/v1/workspaces/{workspace_name}'.format(workspace_name='workspace_name_example'),
            method='DELETE',
            headers=headers)
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_get_file_of_workspace(self):
        """Test case for get_file_of_workspace

        
        """
        headers = { 
            'Accept': 'application/json',
            'ApiKeyAuth': 'special-key',
        }
        response = self.client.open(
            '/api/v1/workspaces/{workspace_name}/files/{filename}'.format(workspace_name='workspace_name_example', filename='filename_example'),
            method='GET',
            headers=headers)
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_get_files_of_workspace(self):
        """Test case for get_files_of_workspace

        
        """
        headers = { 
            'Accept': 'application/json',
            'ApiKeyAuth': 'special-key',
        }
        response = self.client.open(
            '/api/v1/workspaces/{workspace_name}/files'.format(workspace_name='workspace_name_example'),
            method='GET',
            headers=headers)
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_get_workspace(self):
        """Test case for get_workspace

        
        """
        headers = { 
            'Accept': 'application/json',
            'ApiKeyAuth': 'special-key',
        }
        response = self.client.open(
            '/api/v1/workspaces/{workspace_name}'.format(workspace_name='workspace_name_example'),
            method='GET',
            headers=headers)
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_get_workspaces(self):
        """Test case for get_workspaces

        
        """
        headers = { 
            'Accept': 'application/json',
            'ApiKeyAuth': 'special-key',
        }
        response = self.client.open(
            '/api/v1/workspaces',
            method='GET',
            headers=headers)
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    @unittest.skip("multipart/form-data not supported by Connexion")
    def test_upload_files_to_workspace(self):
        """Test case for upload_files_to_workspace

        
        """
        headers = { 
            'Accept': '*/*',
            'Content-Type': 'multipart/form-data',
            'ApiKeyAuth': 'special-key',
        }
        data = dict(workspace=(BytesIO(b'some file data'), 'file.txt'))
        response = self.client.open(
            '/api/v1/workspaces/{workspace_name}/files'.format(workspace_name='workspace_name_example'),
            method='POST',
            headers=headers,
            data=data,
            content_type='multipart/form-data')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))


if __name__ == '__main__':
    unittest.main()
