import threading
import time
import ftlock

from txtapi.handlers import controller_handler
from txtapi.txt.txt_state import TxtState


class Heartbeat:

    TIMEOUT = 10
    __instance = None
    _timestamp = 0
    _thread = None
    _subscribers = []

    @staticmethod
    def get_instance():
        """ Static access method. """
        if Heartbeat.__instance == None:
            Heartbeat()
        return Heartbeat.__instance

    def __init__(self):
        if Heartbeat.__instance != None:
            raise Exception("This class is a singleton!")
        else:
            Heartbeat.__instance = self
            self.start()

    def start(self):
        if self._thread and self._thread.is_alive():
            return
        self._timestamp = time.time()
        self._thread = threading.Thread(target=self.heartbeat)
        self._thread.start()

    def keep_alive(self):
        self._timestamp = time.time()

    def heartbeat(self):
        while True:
            if self.TIMEOUT < (time.time() - self._timestamp):
                if chr(ftlock.state().status) == TxtState.INTERFACE_TEST_START.value:
                    print("Stopping Interface Test")
                    controller_handler.stop_interface_test()
                return
            time.sleep(self.TIMEOUT)

    def subscribe(self, callback):
        self._subscribers.append(callback)
